SystemOrganization addCategory: #'SourceCity-Tools'!

ListItemWrapper subclass: #SourceCityTreeInformation
	instanceVariableNames: 'position orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityTreeInformation methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 7/27/2012 16:53'!
contents

	^(item class allInstVarNames asOrderedCollection withIndexCollect: [:each :index |
		self class
			with: (item name)
			name: each
			model: item]) ",
	((1 to: item basicSize) collect: [:index |
		self class
			with: (item basicAt: index)
			name: index printString
			model: item
			parent: self])"! !

Object subclass: #SourceCityCamera
	instanceVariableNames: 'position orientation'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityCamera commentStamp: '<historical>' prior: 0!
I'm the camera used to sourceCityGL, contain has you can see where the camera is set and direction!

!SourceCityCamera class methodsFor: 'as yet unclassified' stamp: 'blo 7/5/2012 14:42'!
position: aPosition orientation: anOrientation
	^self new position: aPosition; orientation: anOrientation! !

!SourceCityCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:08'!
orientation

	^ orientation copy! !

!SourceCityCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:21'!
orientation: anObject

	orientation := anObject! !

!SourceCityCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 15:08'!
position

	^ position copy! !

!SourceCityCamera methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:21'!
position: anObject

	position := anObject! !

Object subclass: #SourceCityConfiguration
	instanceVariableNames: 'camera backgroundOpenGL city'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityConfiguration commentStamp: '<historical>' prior: 0!
I'm the object needed to sourceCityGL and i contain all the information needed for render the final scene!

!SourceCityConfiguration class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 8/2/2012 16:17'!
city: aCity
	"define default configuration and set the city wich is use for visualizations"
	^self new city: aCity.! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:22'!
backgroundOpenGL
	^ backgroundOpenGL! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:22'!
backgroundOpenGL: anObject
	backgroundOpenGL := anObject! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:22'!
camera

	^ camera! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:22'!
camera: anObject

	camera := anObject! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'blo 7/5/2012 13:22'!
city

	^ city! !

!SourceCityConfiguration methodsFor: 'accessing' stamp: 'DouailleErwan 7/10/2012 10:41'!
city: anObject

	city := anObject.
	camera := SourceCityCamera position: (Point3D x: 0 y: 0 z: (0 - self city dimension x *5)) 
		orientation: (Point3D x: -214 y: 42 z: 0).! !

!SourceCityConfiguration methodsFor: 'initialize-release' stamp: 'DouailleErwan 8/2/2012 16:16'!
initialize
	"define a default camera"
	camera := SourceCityCamera position: (Point3D x: 0 y: 0 z: 0) orientation: (Point3D x: 0 y: 0 z: 0).
	"define a default opengl background"
	backgroundOpenGL := Color white.! !

StandardWindow subclass: #SourceCityUI
	instanceVariableNames: 'window informationDisplay cityInformation sourceCityGL selectedElement'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!SourceCityUI commentStamp: '<historical>' prior: 0!
I am the window where you can watch source City, i also have some buttons and stuff for documentation picking!

!SourceCityUI class methodsFor: 'as yet unclassified' stamp: 'DouailleErwan 6/24/2012 13:19'!
initialize: aSourceCityGL
	^self new sourceCityGL: aSourceCityGL! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 15:36'!
addAll
	self addMorph: self sourceCityGL
		fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0.5));
		addMorph: self downPanel
		fullFrame: (LayoutFrame fractions: (0@0.5 corner: 1@1)).! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 13:45'!
buildInformation
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/30/2012 15:34'!
buttons

	^  (self newRow: {
		self newButtonFor: self sourceCityGL camera action: #cameraOnTop label: 'Top view' help: ''.
		self newButtonFor: self sourceCityGL camera action: #cameraOnNormal label: 'Normal view' help: ''.
		self newButtonFor: self sourceCityGL renderer action: #depenciesOfSelectedElement label: 'Dependencies' help: ''.
		self newButtonFor: self action: #screenShot label: 'Take a screenshot' help: ''.
		})! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/26/2012 17:23'!
cityInformation
	^ cityInformation contents! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 12:10'!
cityInformation: anObject
	cityInformation := anObject.! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/2/2012 14:43'!
citySetInformation: anObject
	cityInformation contents: anObject asString! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/30/2012 09:43'!
downPanel
	^  (	 self newColumn: {
			(self newRow: {self buttons}).
			(self newRow: { 
				(self newColumn: {
					(self newRow: {
					self buildInformation."
					self treeInformation"
					})vResizing: #spaceFill
				})vResizing: #spaceFill
			}) vResizing: #spaceFill.
		}).! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/2/2012 12:09'!
getInformation
	(self sourceCityGL selectedElement isNil)
	ifTrue: [self citySetInformation: ''] 
	ifFalse: [self citySetInformation: self  sourceCityGL selectedElement].! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/25/2012 10:33'!
information
	^(self newTitle: 'Picking information' for: (
		(self newTextEditorFor: cityInformation
			getText: #contents
			setText: #contents:) 
		disable;minWidth: 100;
		minHeight: 50)
		).! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/20/2012 11:24'!
informationDisplay
	^ informationDisplay! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/20/2012 11:24'!
informationDisplay: anObject
	informationDisplay := anObject! !

!SourceCityUI methodsFor: 'initialize' stamp: 'DouailleErwan 7/20/2012 11:47'!
initialize
	| info |
	super initialize.
	info := ValueHolder new contents: ''.
	self cityInformation:  info.
	selectedElement := nil.! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 6/24/2012 19:27'!
menu! !

!SourceCityUI methodsFor: 'initialize' stamp: 'blo 7/5/2012 14:50'!
openInWorld
	| container |
	self addAll.
	super openInWorld.
	self themeChanged;
		title: 'SourceCity: ', self sourceCityGL sourceCityConfiguration city name;
		width: 700;
		height: 500! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/30/2012 15:39'!
screenShot
	"should add a window in future version where you can chose the extension ... for the moment png"
	self sourceCityGL exportAsPNG! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/20/2012 11:24'!
selectedElement
	^ selectedElement! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 7/30/2012 15:39'!
selectedElement: anObject
	selectedElement := anObject.
	anObject isNil 
	ifTrue: [cityInformation contents: 'nothing is selected'.]
	ifFalse: [cityInformation contents: anObject asString.].
	 ! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/25/2012 10:33'!
sourceCityGL
	^ sourceCityGL! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:44'!
sourceCityGL: anObject
	sourceCityGL := anObject! !

!SourceCityUI methodsFor: 'display' stamp: 'DouailleErwan 7/27/2012 16:51'!
treeInformation

	^(self newTitle: 'Picking tree information' for: (
		(SimpleHierarchicalListMorph
			on: [ Array with:  (SourceCityTreeInformation with: sourceCityGL sourceCityConfiguration city )  ]
			list: #value
			selected: nil
			changeSelected: nil
			menu: nil
			keystroke: nil)
			)
	).! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window
	^ window! !

!SourceCityUI methodsFor: 'accessing' stamp: 'DouailleErwan 6/24/2012 19:12'!
window: anObject
	window := anObject! !
